# API Doc

JS-PackTools contains multiple functions that we group by categories to make it easier to find what you need. Each function contains details of its operation and example. you just have to click on the function you need and you will get all the information.
___
>## 🧾 Arrays/Object 

| Functions Name | version | Category | Description |
|---|---|---|---|
|🌱  [**allEqual**](https://jasp402.github.io/js-packtools/#/en/api/v1/allEqual) | 2.0.0 | Arrays/Object | <sub>This snippet checks whether all elements of the array are equal.</sub> |
|🌱  [**everyOrNone**](https://jasp402.github.io/js-packtools/#/en/api/v1/everyOrNone) | 1.0.0 | Arrays/Object | <sub>This snippet returns true if the predicate function returns true for a...</sub> |
|🌱  [**groupBy**](https://jasp402.github.io/js-packtools/#/en/api/v1/groupBy) | 1.0.0 | Arrays/Object | <sub>Sort the object by placing the value of the assigned property as key</sub> |
|🌱  [**objectFilter**](https://jasp402.github.io/js-packtools/#/en/api/v1/objectFilter) | 1.1.2 | Arrays/Object | <sub>This fragment allows you to filter an object and return the key and it...</sub> |
>## ✍ String 

| Functions Name | version | Category | Description |
|---|---|---|---|
|🌱  [**capitalLetter**](https://jasp402.github.io/js-packtools/#/en/api/v1/capitalLetter) | 2.0.0 | String | <sub>capitalize the first letter of a sentence or all letters if second par...</sub> |
|🌱  [**modEnd**](https://jasp402.github.io/js-packtools/#/en/api/v1/modEnd) | 1.0.1 | String | <sub>Using a string to create a new string with new size inverse to modStar...</sub> |
|🌱  [**modStart**](https://jasp402.github.io/js-packtools/#/en/api/v1/modStart) | 1.0.1 | String | <sub>Using a string to create a new string with new size.</sub> |
>## 📁 Path/Files 

| Functions Name | version | Category | Description |
|---|---|---|---|
|🌱  [**clearFolders**](https://jasp402.github.io/js-packtools/#/en/api/v1/clearFolders) | 1.0.0 | Path/Files | <sub>This simply clear the content a folder.</sub> |
|🌱  [**createFolders**](https://jasp402.github.io/js-packtools/#/en/api/v1/createFolders) | 1.0.0 | Path/Files | <sub>This create a folder whit sub-folder of date by default if param `with...</sub> |
|🌱  [**deleteFile**](https://jasp402.github.io/js-packtools/#/en/api/v1/deleteFile) | 1.0.0 | Path/Files | <sub>Check if the file exists before deleting</sub> |
|🌱  [**getFinalPath**](https://jasp402.github.io/js-packtools/#/en/api/v1/getFinalPath) | 1.0.0 | Path/Files | <sub>Create structure of folders with parameters in constructor.</sub> |
|🌱  [**renameFiles**](https://jasp402.github.io/js-packtools/#/en/api/v1/renameFiles) | 1.0.0 | Path/Files | <sub>This function rename a batch of files with current date or token uniqu...</sub> |
|🌱  [**validateDir**](https://jasp402.github.io/js-packtools/#/en/api/v1/validateDir) | 1.0.0 | Path/Files | <sub>Validate if there is a route. if not, create this route.</sub> |
>## ↔ convert 

| Functions Name | version | Category | Description |
|---|---|---|---|
|🌱  [**csvToJson**](https://jasp402.github.io/js-packtools/#/en/api/v1/csvToJson) | 1.0.0 | convert | <sub>This read a document CSV and convert in a Object Javascript (JSON).</sub> |
|🌱  [**jsonToCsv**](https://jasp402.github.io/js-packtools/#/en/api/v1/jsonToCsv) | 1.0.1 | convert | <sub>Function for convert JSON to CSV</sub> |
>## ⏰ Time/Date 

| Functions Name | version | Category | Description |
|---|---|---|---|
|🌱  [**customDate**](https://jasp402.github.io/js-packtools/#/en/api/v1/customDate) | 1.0.0 | Time/Date | <sub>It's a date control. Without parameters give the current date, use the...</sub> |
|🌱  [**dayOfYear**](https://jasp402.github.io/js-packtools/#/en/api/v1/dayOfYear) | 1.0.0 | Time/Date | <sub>This snippet gets the day of the year from a Date object.</sub> |
|🌱  [**differenceDay**](https://jasp402.github.io/js-packtools/#/en/api/v1/differenceDay) | 1.0.0 | Time/Date | <sub>This simply clear the content a folder.</sub> |
|🌱  [**formatSeconds**](https://jasp402.github.io/js-packtools/#/en/api/v1/formatSeconds) | 1.0.1 | Time/Date | <sub>This only format a value float</sub> |
|🌱  [**generateRageDate**](https://jasp402.github.io/js-packtools/#/en/api/v1/generateRageDate) | 1.0.0 | Time/Date | <sub>This function allows you to separate a given date in the number of day...</sub> |
|🌱  [**increaseDays**](https://jasp402.github.io/js-packtools/#/en/api/v1/increaseDays) | 1.0.0 | Time/Date | <sub>Add days to date, can defined a maxDate.</sub> |
|🌱  [**objectToDate**](https://jasp402.github.io/js-packtools/#/en/api/v1/objectToDate) | 1.0.0 | Time/Date | <sub>Generate a object with date details.</sub> |
|🌱  [**parseDate**](https://jasp402.github.io/js-packtools/#/en/api/v1/parseDate) | 1.0.1 | Time/Date | <sub>Using a string and a format transform the string in date.</sub> |
|🌱  [**timeToDate**](https://jasp402.github.io/js-packtools/#/en/api/v1/timeToDate) | 1.0.1 | Time/Date | <sub>return the time between two dates, or a date and now</sub> |
|🌱  [**validateYear**](https://jasp402.github.io/js-packtools/#/en/api/v1/validateYear) | 1.0.0 | Time/Date | <sub>Can be current year or spend the year to validate</sub> |
>## ✔ validate 

| Functions Name | version | Category | Description |
|---|---|---|---|
|🌱  [**is**](https://jasp402.github.io/js-packtools/#/en/api/v1/is) | 1.0.1 | validate | <sub>Is a function for evaluate to type of element</sub> |
>## 🌐 global 

| Functions Name | version | Category | Description |
|---|---|---|---|
|🌱  [**writeLog**](https://jasp402.github.io/js-packtools/#/en/api/v1/writeLog) | 1.0.0 | global | <sub>write file .log in folder default of class.</sub> |
|🌱  [**writeLogError**](https://jasp402.github.io/js-packtools/#/en/api/v1/writeLogError) | 1.0.0 | global | <sub>write file .log in folder default of class.</sub> |
|🌱  [**log**](https://jasp402.github.io/js-packtools/#/en/api/v1/log) | 1.0.0 | global | <sub>It integrates the functions registry of errors and registry of executi...</sub> |

___
:seedling: **Completed** <br>
:fire: **In Development** <br>
:speech_balloon: **proposal** <br>
⛔ **deprecated** <br>
